<?php

namespace Factory;

use Doctrine\ORM\EntityManager;
use Traits\TQuery;

class FaturamentoFactory
{

    use TQuery;

    private $connection;

    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    // Já atualizado
    public function getFaturamento($dtinicompetFilter, $dtfincompetFilter, $dtinicompetFilterMed,  $dtfincompetFilterMed, $qtMesesExibicao = -2, $params)
    {
        $sql =  "SELECT *
        FROM (
     SELECT DISTINCT
        DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO,
        AGRUPCONT.IDPARCAGRUP,
        TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
        DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT,  AGRUPA.NMAGRUPAMENTO|| '-' ||DSOBSAGRUPAMENTO) AS NRCONTRATOFCT,
        CASE AGRUPCONT.IDPARCAGRUP WHEN 'N'
             THEN TO_CHAR(CONT.NRSEQCONTRATO)
             ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                     FROM FCT_RELACAGRUPCONTFAT
                    WHERE NRFATURACONT = FAT.NRFATURACONT)
         END AS NRSEQCONTRATO,
        DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT,
        DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS IDTIPO,
        FAT.NRGRUPOFATURA,
        FAT.CDFILIALFATURA,
        FILIFAT.NMFILIAL AS NMFILIALFATURA,
        FAT.NRPARCFATURA,
        PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA,
        FAT.IDTPFATURA,
        CASE
            WHEN FIN.IDSTATREC = 'B' THEN 'RECEBIDO'
            WHEN FIN.IDSTATREC = 'P'  THEN 'PLANEJADO'
            WHEN TRUNC(FIN.DTATUAVENREC) < TRUNC(SYSDATE) THEN 'ATRASO'
            ELSE 'FATURADA'
        END AS IDSITUACAO,
        DECODE(FAT.NRFATURACONT, NULL, TRUNC(FIN.DTEMISSAO, 'mm'), FAT.DTINICOMPET) AS DTINICOMPET,
        DECODE(FAT.NRFATURACONT, NULL, LAST_DAY(FIN.DTEMISSAO), FAT.DTFINCOMPET) AS DTFINCOMPET,
        FAT.DTLIMITEAPU,
        DECODE(FIN.NRNOTAFISC, NULL, NULL, FIN.DTATUAVENREC) AS DTVENCIMENTO,
        FAT.NRDIASVENCIMENTO,
        FAT.QTDIASFATUVENC,
        NVL(NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO), (SUM(FIN.VRLIQUIDBOL) OVER (PARTITION BY FIN.CDFILIAL, FIN.NRLANCTONF, AGRUPCONT.NRAGRUPCONTFAT))) AS VRVENCIMENTO,
        NVL(FAT.VRVENCIMENTO, (SUM(FIN.VRLIQUIDBOL) OVER (PARTITION BY FIN.CDFILIAL, FIN.NRLANCTONF, AGRUPCONT.NRAGRUPCONTFAT))) AS VRORIGINAL,
        FAT.VRFATURADO,
        FAT.VRFALTAFATURAR,
        FAT.IDFORMAFATURA,
        FAT.IDALTUSUARIO,
        FAT.NRAPURACAO,
        FIN.NRLANCTONF,
        FIN.CDFILIAL AS CDFILIALNF,
        FILINF.NMFILIAL AS NMFILIALNF,
        FIN.NRNOTAFISC,
        FIN.DTENTRSAID,
        FAT.IDATIVO,
        FAT.NRORG,
        FAT.DTINCLUSAO,
        FAT.NRORGINCLUSAO,
        FAT.CDOPERINCLUSAO,
        FAT.DTULTATU,
        FAT.NRORGULTATU,
        FAT.CDOPERULTATU,
        DECODE(AGRUPCONT.IDPARCAGRUP, 'S', AGRUPA.DSOBSAGRUPAMENTO, CONT.DSREFERENCIACONT) DSREFERENCIACONT,
        FIN.VRNOTAFISC,
        DECODE(FIN.NRNOTAFISC, NULL, NULL, FIN.VRATUAREC) AS VRATUAREC,
        RELAGRUPCONT.NRAGRUPAMENTO,
        FAT.VRNEGCONTR,
       DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO) AS NRORCAMENTO,
       NVL(DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO),  DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO)) AS NRPROPOSTA

       FROM (SELECT BO.IDSTATBREC, CL.NRPARCNEGOCIO, NF.DTEMISSAO, NF.DTENTRSAID,
                    NRNOTAFISC,
                    NF.CDSERIE,
                    CL.NRINSJURCLIE,
                    CL.NMRAZSOCCLIE,
                    NF.VRPRODUTOS,
                    NF.VRNOTAFISC,
                    NVL(IM.VRRETENCAO,0) AS VRRETIDO,
                    CR.VRORIGREC ,
                   (CR.VRATUAREC - CR.VRORIGREC) AS VRAJUSTECONTA,
                    ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))) - (CR.VRATUAREC ),2) AS VRAJUSTEBOL,
                    ROUND(ROUND(CR.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CR.VRATUAREC/(DECODE(BO.VRBOLREC, 0, 1, BO.VRBOLREC)))),2) AS VRLIQUIDBOL,
                    CR.VRATUAREC,
                    CR.NRPARCELAREC,
                    CR.DSCONTAREC,
                    CR.DTORIGVENREC,
                    CR.DTATUAVENREC,
                    BR.DTBAIXAREC,
                    BO.IDSTATBREC AS IDSTATREC,
                    DECODE(BO.IDSTATBREC, 'P','PLANEJADO', 'A', 'EM ABERTO', 'E', 'EMITIDO', 'B', 'BAIXADO')  AS STATUS,
                    COUNT(*) OVER(PARTITION BY NF.CDFILIAL,NF.NRLANCTONF) AS QUANT,
                    E.NMEMPRESA,
                    E.NRINSJUREMPR,
                    NF.NRORG,
                    NF.CDFILIAL,
                    NF.NRLANCTONF,
                    CASE WHEN (CR.DTATUAVENREC < TRUNC(SYSDATE)) AND (BO.IDSTATBREC IN ('A','E'))
                         THEN 'V'
                         WHEN (CR.DTATUAVENREC >= TRUNC(SYSDATE)) AND (BO.IDSTATBREC IN ('A','E'))
                         THEN 'P'
                         ELSE 'E'
                     END AS VALIDATOR
               FROM NOTAFISCAL NF, CONTARECEBER CR, BOLETRECEBER BO, CLIENTE CL, EMPRESA E, BAIXARECEBIDA BR,
                    (SELECT SUM(VRIMPOSTONF) AS VRRETENCAO, CDFILIAL, NRLANCTONF
                       FROM IMPOSTONF I, IMPOSTO II
                      WHERE I.CDIMPOSTO = II.CDIMPOSTO
                        AND II.IDTRATIMPO = 'R'
                      GROUP BY CDFILIAL, NRLANCTONF) IM
              WHERE NF.CDCLIENTE = CL.CDCLIENTE
                AND CL.NRPARCNEGOCIO = :NRPARCNEGOCIO
                AND NF.CDFILIAL = CR.CDFILIAL
                AND NF.NRLANCTONF = CR.NRLANCTONF
                AND CR.CDFILIBOLREC = BO.CDFILIAL
                AND CR.NRLANBOLREC = BO.NRLANBOLREC
                AND BO.CDFILIBAIREC = BR.CDFILIAL(+)
                AND BO.NRBAIXAREC  = BR.NRBAIXAREC(+)
                AND IM.CDFILIAL(+) = NF.CDFILIAL
                AND IM.NRLANCTONF(+) = NF.NRLANCTONF
                AND E.CDEMPRESA      = NF.CDEMPRESA) FIN
       LEFT JOIN FCT_APURACAO APU
              ON APU.CDFILIAL = FIN.CDFILIAL
             AND APU.NRLANCTONF = FIN.NRLANCTONF
       LEFT JOIN FCT_RELACAPURACAOFATURA REL
              ON REL.NRAPURACAO = APU.NRAPURACAO
       LEFT JOIN FCT_FATURACONT FAT
              ON FAT.NRFATURACONT = REL.NRFATURACONT
       LEFT JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
              ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
             AND FAT.NRORG = AGRUPCONT.NRORG
       LEFT JOIN FCT_CONTRATO CONT
              ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
             AND AGRUPCONT.NRORG = CONT.NRORG
       LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
              ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
             AND RELAGRUPCONT.NRORG = CONT.NRORG
       LEFT JOIN FCT_AGRUPAMENTO AGRUPA
              ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
             AND AGRUPA.NRORG = RELAGRUPCONT.NRORG
       LEFT JOIN FILIAL FILIFAT
              ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
             AND FAT.NRORG          = FILIFAT.NRORG
      INNER JOIN PARCNEGOCIO PARCFAT
              ON PARCFAT.NRPARCNEGOCIO = FIN.NRPARCNEGOCIO
             AND PARCFAT.NRORG = FIN.NRORG
       LEFT JOIN FILIAL FILINF
              ON FILINF.CDFILIAL = FIN.CDFILIAL
       LEFT JOIN FCT_REFEORCACONT REFORC
              ON REFORC.NRSEQCONTRATO = CONT.NRSEQCONTRATO
       LEFT JOIN FCT_ORCAMENTO ORC
              ON ORC.NRSEQORCAMENTO = REFORC.NRSEQORCAMENTO
           $dtinicompetFilter
           $dtfincompetFilter

      UNION ALL

     SELECT DISTINCT DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO, AGRUPCONT.IDPARCAGRUP, TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
                     DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO) AS NRCONTRATOFCT,
                     CASE AGRUPCONT.IDPARCAGRUP
                          WHEN 'N'
                          THEN TO_CHAR(CONT.NRSEQCONTRATO)
                          ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                                  FROM FCT_RELACAGRUPCONTFAT
                                 WHERE NRFATURACONT = FAT.NRFATURACONT)
                      END AS NRSEQCONTRATO,
                     DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT,
                     DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS IDTIPO,
                     FAT.NRGRUPOFATURA, FAT.CDFILIALFATURA, FILIFAT.NMFILIAL AS NMFILIALFATURA,
                     FAT.NRPARCFATURA, PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA, FAT.IDTPFATURA,
                     'PENDENTE' AS IDSITUACAO,
                     FAT.DTINICOMPET, FAT.DTFINCOMPET,
                     FAT.DTLIMITEAPU, NULL AS DTVENCIMENTO, FAT.NRDIASVENCIMENTO, FAT.QTDIASFATUVENC, NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) AS VRVENCIMENTO, FAT.VRVENCIMENTO AS VRORIGINAL,
                     FAT.VRFATURADO, FAT.VRFALTAFATURAR, FAT.IDFORMAFATURA, FAT.IDALTUSUARIO, FAT.NRAPURACAO, NF.NRLANCTONF,
                     NF.CDFILIAL AS CDFILIALNF, FILINF.NMFILIAL AS NMFILIALNF, NF.NRNOTAFISC, NF.DTENTRSAID, FAT.IDATIVO,
                     FAT.NRORG, FAT.DTINCLUSAO, FAT.NRORGINCLUSAO, FAT.CDOPERINCLUSAO, FAT.DTULTATU, FAT.NRORGULTATU,
                     FAT.CDOPERULTATU,
                     DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.DSREFERENCIACONT, AGRUPA.DSOBSAGRUPAMENTO) DSREFERENCIACONT,
                     NF.VRNOTAFISC,
                     NULL AS VRATUAREC,
                     RELAGRUPCONT.NRAGRUPAMENTO,
                     FAT.VRNEGCONTR,
                      DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO) AS NRORCAMENTO,
                      NVL(DECODE(AGRUPCONT.IDPARCAGRUP, 'N', ORC.NRORCAMENTO, AGRUPA.NMAGRUPAMENTO),  DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO)) AS NRPROPOSTA

       FROM FCT_FATURACONT FAT
      INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
              ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
             AND FAT.NRORG        = AGRUPCONT.NRORG
       LEFT JOIN FCT_CONTRATO CONT
              ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
             AND AGRUPCONT.NRORG         = CONT.NRORG
       LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
              ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
             AND RELAGRUPCONT.NRORG         = CONT.NRORG
       LEFT JOIN FCT_AGRUPAMENTO AGRUPA
              ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
             AND AGRUPA.NRORG         = RELAGRUPCONT.NRORG
      INNER JOIN FILIAL FILIFAT
              ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
             AND FAT.NRORG          = FILIFAT.NRORG
      INNER JOIN PARCNEGOCIO PARCFAT
              ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
             AND FAT.NRORG = PARCFAT.NRORG
       LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                         NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                         NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                    FROM FCT_RELACAPURACAOFATURA APURFAT
                   INNER JOIN FCT_APURACAO APU
                           ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                          AND APURFAT.NRORG      = APU.NRORG
                    LEFT JOIN NOTAFISCAL NF
                           ON APU.NRLANCTONF = NF.NRLANCTONF
                          AND APU.CDFILIAL   = NF.CDFILIAL
                   GROUP BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
              ON FAT.NRFATURACONT = NF.NRFATURACONT
             AND FAT.NRORG = NF.NRORG
       LEFT JOIN FILIAL FILINF
              ON NF.CDFILIAL = FILINF.CDFILIAL
       LEFT JOIN FCT_REFEORCACONT REFORC
              ON REFORC.NRSEQCONTRATO = CONT.NRSEQCONTRATO
       LEFT JOIN FCT_ORCAMENTO ORC
              ON ORC.NRSEQORCAMENTO = REFORC.NRSEQORCAMENTO
      WHERE FAT.NRORG        = :NRORG
        AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
        AND FAT.DTINICOMPET > LAST_DAY(ADD_MONTHS(TRUNC(SYSDATE),  $qtMesesExibicao))
        AND CONT.IDATIVO     = 'S'
        AND FAT.IDSITUACAO IN ('1', '2', '6')

      UNION ALL

     SELECT NVL2(MED.NRAGRUPAMENTO, 'AME', 'M') AS TIPO,
            NULL AS IDPARCAGRUP,
            NULL AS DSJUSTIFICATIVA,
            MED.NRCONTRATOFCT,
            MED.NRSEQCONTRATO,
            NVL2(MED.NRAGRUPAMENTO, NULL, 'M') || MED.NRMEDICAOFATURA AS NRFATURACONT,
            NVL2(MED.NRAGRUPAMENTO, 'AME', 'M') AS IDTIPO,
            MED.NRGRUPOFATURA,
            MED.CDFILIALFATURA,
            MED.NMFILIALFATURA,
            MED.NRPARCFATURA,
            MED.NMPARCFATURA,
            MED.IDTPFATURA,
            'ESTIMADO' AS IDSITUACAO,
            MED.DTINICOMPET,
            MED.DTFINCOMPET,
            MED.DTLIMITEAPU,
            NULL AS DTVENCIMENTO,
            MED.NRDIASVENCIMENTO,
            MED.QTDIASFATUVENC,
            NVL(MED.VRNEGCONTR, MED.PRECOMEDICAO) AS VRVENCIMENTO,
            MED.PRECOMEDICAO AS VRORIGINAL,
            0 AS VRFATURADO,
            NVL(MED.VRNEGCONTR, MED.PRECOMEDICAO) AS VRFALTAFATURAR,
            NULL AS IDFORMAFATURA,
            NULL AS IDALTUSUARIO,
            NULL AS NRAPURACAO,
            NULL AS NRLANCTONF,
            NULL AS CDFILIALNF,
            NULL AS NMFILIALNF,
            NULL AS NRNOTAFISC,
            NULL AS DTENTRSAID,
            MED.IDATIVO,
            MED.NRORG,
            MED.DTINCLUSAO,
            MED.NRORGINCLUSAO,
            MED.CDOPERINCLUSAO,
            MED.DTULTATU,
            MED.NRORGULTATU,
            MED.CDOPERULTATU,
            MED.DSREFERENCIACONT,
            NULL AS VRNOTAFISC,
            NULL AS VRATUAREC,
            MED.NRAGRUPAMENTO,
            MED.VRNEGCONTR,
            ORC.NRORCAMENTO,
            NVL(NRORCAMENTO,MED.NRCONTRATOFCT) AS NRPROPOSTA
       FROM TABLE(FCT_BUSCA_PRECOMEDICAO(:NRPARCNEGOCIO, :NRORG)) MED
       LEFT JOIN FCT_REFEORCACONT REFORC
              ON REFORC.NRSEQCONTRATO = DECODE(LENGTH(TRIM(TRANSLATE(MED.NRSEQCONTRATO, '0123456789',' '))) ,NULL,MED.NRSEQCONTRATO)
       LEFT JOIN FCT_ORCAMENTO ORC
              ON ORC.NRSEQORCAMENTO = REFORC.NRSEQORCAMENTO
      WHERE MED.DTINICOMPET > LAST_DAY(ADD_MONTHS(TRUNC(SYSDATE), $qtMesesExibicao))

           $dtinicompetFilterMed
           $dtfincompetFilterMed
     )
                     WHERE
                            1 = 1
                     AND idsituacao IN ( 'PENDENTE', 'ESTIMADO', 'ATRASO', 'FATURADA', 'PLANEJADO' )
                     ORDER BY DTINICOMPET ASC, NRSEQCONTRATO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    // já atualizado.
    public function getFaturamentoValorFixo($params)
    {
        $sql = "SELECT :VRNEGCONTR AS VRNEGCONTR1,
        :VRORIGINAL AS VRORIGINAL,
        :DTINICOMPET AS DTINICOMPET, 
        :DTFINCOMPET AS DTFINCOMPET,  
        :NRAGRUPAMENTO AS NRAGRUPAMENTO, 
         TO_CHAR(ITCONT.NRITEMOCONTRATO) AS IDARVORE, 
         NULL AS IDARVOREPAI, 
         CONT.NRSEQCONTRATO, 
         CONT.NRCONTRATOFCT, 
         ITFAT.NRFATURACONT, 
         ITFAT.NRITFATURACONT,
         ITCONT.VRUNITITEMCONT AS VRUNITARIO,
         ITCONT.QTMEDIDACONTR AS QTCONSIDERADA,
         NVL(ITNEG.VRTOTITEM, ITCONT.VRTOTITEMCONT) AS VRSEMDESCONTO, 
         NVL(ITNEG.VRPERCDESCITEM, NVL(NEG.VRPERCDESCITEM ,0)) AS VRPERCDESCITEM, 
         NVL(ITNEG.VRDESCITEM, NVL(NEG.VRDESCITEM, 0)) AS VRDESCITEM,
         ITFAT.VRVENCIMENTO, 
         DECODE(REL.IDPARCAGRUP, 'S', DECODE(ITCONT.NRITEMCONTRATOPAI, NULL, ITCONT.NMITEMCONTRATO || '(' || CONT.NRCONTRATOFCT || ')', ITCONT.NMITEMCONTRATO), ITCONT.NMITEMCONTRATO) AS NMITEMCONTRATO, 
         ITFAT.IDFORMAFATURA, 
         FAT.IDALTUSUARIO, 
         FAT.DSJUSTIFICATIVA, 
         'N' AS VARIABLE_MEASURE, 
         ITCONT.IDELEMENTO, 
         ITCONT.CDSERVORCA, 
         0 AS ISSERV, 
         ITFAT.NRPARCELASNEGCONTR, 
         ROUND(NVL2(ITFAT.NRPARCELASNEGCONTR, 
         ITFAT.VRNEGCONTR, FAT.VRNEGCONTR / FAT.VRVENCIMENTO * ITFAT.VRVENCIMENTO), 2) AS VRNEGCONTR
         FROM FCT_ITFATURACONT ITFAT 
         INNER JOIN FCT_FATURACONT FAT 
           ON ITFAT.NRFATURACONT = FAT.NRFATURACONT 
         INNER JOIN FCT_RELACAGRUPCONTFAT REL 
           ON FAT.NRFATURACONT = REL.NRFATURACONT 
         INNER JOIN FCT_CONTRATO CONT 
           ON REL.NRSEQCONTRATO = CONT.NRSEQCONTRATO 
         INNER JOIN FCT_ITEMCONTRATO ITCONT 
         ON REL.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
             AND ITFAT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO 
         INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG 
            ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO 
         INNER JOIN FCT_NEGOCIACAOCONTRATO NEG 
            ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO 
            AND CONT.NRSEQCONTRATO = NEG.NRSEQCONTRATO 
     WHERE 'P' || FAT.NRFATURACONT = :NRFATURACONT 
             AND REL.NRMEDICAOFATURA IS NULL 
             AND FAT.NRMEDICAOFATURA IS NULL 
             AND CONT.NRORG = :NRORG
             AND CONT.NRPARCNEGOCIO = :NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    // Já Atualizado
    public function getFaturamentoNaoAgrupado($params)
    {
        $sql =  "SELECT IDARVORE,
        :DTINICOMPET AS DTINICOMPET,
        :DTFINCOMPET AS DTFINCOMPET,
        :NRAGRUPAMENTO AS NRAGRUPAMENTO,
        IDARVOREPAI,
        NRSEQCONTRATO,
        NRCONTRATOFCT,
        NRFATURACONT,
        NRITFATURACONT,
        VRUNITARIO,
        VRSEMDESCONTO,
        VRVENCIMENTO,
        VRPERCDESCITEM,
        VRDESCITEM,
        NMITEMCONTRATO,
        IDFORMAFATURA,
        IDALTUSUARIO,
        DSJUSTIFICATIVA,
        VARIABLE_MEASURE,
        IDELEMENTO,
        CDSERVORCA,
        ISSERV,
        NVL2(IDARVOREPAI, NULL, VRNEGCONTR) AS VRNEGCONTR,
        QTMEDIDACONTR AS QTMINIMA,
        QTMEDIDAMEDICAO AS QTCONSIDERADA
 FROM
     (SELECT IDARVORE,
             IDARVOREPAI,
             NRSEQCONTRATO,
             NRCONTRATOFCT,
             NRFATURACONT,
             NRITFATURACONT,
             ROUND(VRUNITARIO,2) AS VRUNITARIO,
             ROUND(VRSEMDESCONTO, 2) AS VRSEMDESCONTO,
             ROUND(VRVENCIMENTO,2) AS VRVENCIMENTO,
             ROUND(VRPERCDESCITEM, 2) AS VRPERCDESCITEM,
             ROUND(VRDESCITEM, 2) AS VRDESCITEM,
             NMITEMCONTRATO,
             IDFORMAFATURA,
             IDALTUSUARIO,
             DSJUSTIFICATIVA,
             'Y' AS VARIABLE_MEASURE,
             IDELEMENTO,
             CDSERVORCA,
             ISSERV,
             VRNEGCONTR,
             QTMEDIDACONTR,
             QTMEDIDAMEDICAO
      FROM
          (SELECT IDARVORE,
                  IDARVOREPAI, 
                  NRSEQCONTRATO,
                  NRCONTRATOFCT,
                  IDSITUACAO,
                  NRFATURACONT,
                  NRITFATURACONT,
                  VRUNITARIO,
                  DECODE(IDARVOREPAI, NULL,  (SELECT SUM(VRITEMCONT) 
                       FROM FCT_MEDVARMEDICAOFATURA
                       WHERE 'M'||NRMEDICAOFATURA = :NRFATURACONT), DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR)) AS VRSEMDESCONTO,
                  CASE
                      WHEN IDARVOREPAI IS NULL THEN VRITEMCONT
                      ELSE VRITEMCONTCOMDESC_MEDVAR
                  END AS VRVENCIMENTO,


                  NVL(VRPERCDESCITEM_ITNEG, DECODE(IDARVOREPAI, NULL, DECODE(VRTOTITEMCONT, 0, 0, (VRDESCITEM * 100) / VRTOTITEMCONT), DECODE(VRITEMCONT_MEDVAR, 0, 0, (VRDESCITEM * 100) / VRITEMCONT_MEDVAR))) AS VRPERCDESCITEM,
                  VRDESCITEM,
                  DECODE(LIC.NMLINPCLIE, NULL, NMITEMCONTRATO, NMITEMCONTRATO|| ' (' || LIC.NMLINPCLIE || ')') AS NMITEMCONTRATO,
                  IDFORMAFATURA,
                  IDALTUSUARIO,
                  DSJUSTIFICATIVA,
                  VRTOTITEMCONT,
                  QTMEDIDACONTR,
                  QTMEDIDAMEDICAO,
                  IDELEMENTO,
                  CDSERVORCA,

                  VRITEMCONT_MEDVAR,
                  VRITEMCONTCOMDESC_MEDVAR,

                  VRPERCDESCITEM_ITNEG, 
                  VRDESCITEM_ITNEG,
                  VRTOTITEM_ITNEG,


               (SELECT COUNT(*)
                FROM FCT_RELACMEDIDACONTRATO
                WHERE NRSEQCONTRATO =NRSEQCONTRATO
                    AND CDSERVORCA = TBL.CDSERVORCA) AS ISSERV,
                  NVL2(IDARVOREPAI, NULL, NVL2(NRPARCELASNEGCONTR, VRNEGCONTR, :VRNEGCONTR / :VRORIGINAL * VRITEMCONT)) AS VRNEGCONTR
           FROM
               (SELECT TO_CHAR(ITCONT.NRITEMOCONTRATO) AS IDARVORE,
                       TO_CHAR(ITCONT.NRITEMCONTRATOPAI) AS IDARVOREPAI,
                       CONT.NRSEQCONTRATO,
                       CONT.NRCONTRATOFCT,
                       MED.IDSITUACAO,
                       ITMED.NRMEDICAOFATURA AS NRFATURACONT,
                       ITMED.NRITMEDICAOFATURA AS NRITFATURACONT,
                       ITMED.VRITEMCONT,
                       DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, NULL, DECODE(MEDVAR.QTMEDIDAMEDICAO, 0, 0, DECODE(NVL(VAR.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, ITCONT. VRUNITITEMCONT / VARVEND.VRPRECOVARIACAO * VAR.VRPRECOVARIACAO)))) AS VRUNITARIO,
                       ITCONT.NMITEMCONTRATO,
                       NULL AS IDFORMAFATURA,
                       NULL AS IDALTUSUARIO,
                       NULL AS DSJUSTIFICATIVA,
                       ITCONT.QTMEDIDACONTR,
                       ITMED.VRTOTITEMCONT,
                       DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, (NVL(ITMED.VRTOTITEMCONT, 0) - NVL(ITMED.VRITEMCONT, 0)), (NVL(MEDVAR.VRITEMCONT, 0) - NVL(MEDVAR.VRITEMCONTCOMDESC, 0))) AS VRDESCITEM,
                       MEDVAR.IDMULTIPVARIACAO,
                       MEDVAR.QTMEDIDAMEDICAO,
                       ITCONT.IDELEMENTO,
                       ITCONT.CDSERVORCA,
                       NVL2(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.VRNEGCONTR) AS VRNEGCONTR,
                       NVL2(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.NRPARCELASNEGCONTR) AS NRPARCELASNEGCONTR,

                       MEDVAR.VRITEMCONT AS VRITEMCONT_MEDVAR,
                       MEDVAR.VRITEMCONTCOMDESC AS VRITEMCONTCOMDESC_MEDVAR,
               
                       ITNEG.VRPERCDESCITEM as VRPERCDESCITEM_ITNEG, 
                       ITNEG.VRDESCITEM as  VRDESCITEM_ITNEG,
                       ITNEG.VRTOTITEM AS VRTOTITEM_ITNEG
                       
                FROM FCT_ITMEDICAOFATURA ITMED
                INNER JOIN FCT_MEDICAOFATURA MED ON ITMED.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                INNER JOIN FCT_CONTRATO CONT ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                INNER JOIN FCT_ITEMCONTRATO ITCONT ON MED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                AND ITMED.CDSERVORCA = ITCONT.CDSERVORCA
                INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                INNER JOIN FCT_NEGOCIACAOCONTRATO NEG ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                LEFT JOIN FCT_MEDVARMEDICAOFATURA MEDVAR ON MED.NRMEDICAOFATURA = MEDVAR.NRMEDICAOFATURA
                AND ITCONT.CDSERVORCA = MEDVAR.CDSERVORCA
                AND ITCONT.IDELEMENTO = MEDVAR.IDELEMENTORAIZ
                AND ITCONT.CDTPMEDIDAVARIAVEL = MEDVAR.CDTPMEDIDAVARIAVEL
                LEFT JOIN FCT_VARPRECBASESERVCONT VAR ON MED.NRSEQCONTRATO = VAR.NRSEQCONTRATO
                AND ITCONT.CDTPMEDIDASERV = VAR.CDTPMEDIDASERV
                AND ITCONT.CDTPMEDIDAVARIAVEL = VAR.CDTPMEDIDAVARIAVEL
                AND MED.NRORG = VAR.NRORG
                AND MEDVAR.CDSERVORCA = VAR.CDSERVORCA
                AND (MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA) BETWEEN VAR.QTMEDIDAINIVARIACAO AND VAR.QTMEDIDAFIMVARIACAO
                LEFT JOIN FCT_VARPRECBASESERVCONT VARVEND ON MED.NRSEQCONTRATO = VARVEND.NRSEQCONTRATO
                AND ITCONT.CDTPMEDIDASERV = VARVEND.CDTPMEDIDASERV
                AND ITCONT.CDTPMEDIDAVARIAVEL = VARVEND.CDTPMEDIDAVARIAVEL
                AND MED.NRORG = VARVEND.NRORG
                AND MEDVAR.CDSERVORCA = VARVEND.CDSERVORCA
                AND DECODE(NVL(MEDVAR.QTMEDIDAVENDIDA, 0), 0, 1, MEDVAR.QTMEDIDAVENDIDA) BETWEEN VARVEND.QTMEDIDAINIVARIACAO AND VARVEND.QTMEDIDAFIMVARIACAO
                WHERE 'M' || MED.NRMEDICAOFATURA = :NRFATURACONT
                    AND MED.NRORG = :NRORG
                    AND (ITCONT.IDELEMENTO IS NULL
                         OR ITCONT.IDELEMENTO IN
                             (SELECT IDELEMENTORAIZ
                              FROM FCT_RELACMEDIDACONTRATO
                              WHERE NRSEQCONTRATO = CONT.NRSEQCONTRATO))) TBL
           LEFT JOIN
               (SELECT COL.NMLINPCLIE || ' - ' || '(' || TO_CHAR(RTRIM(XMLAGG(XMLELEMENT(e, SI.SGSISTEMA, ', ').EXTRACT('//text()')).GetClobVal(), ', ')|| ')') AS NMLINPCLIE,
                       COL.NRSEQCONTRATO AS NRCONT,
                       COL.NRPRODUTO_ID
                FROM SISTCONTLINP SC,
                     SISTEMA SI,
                     PROCOMERCI PR,
                     CONTRATOLINP COL,
                     CLIENTE CLI
                WHERE SC.CDCLIENTE = CLI.CDCLIENTE
                    AND CLI.NRPARCNEGOCIO = :NRPARCNEGOCIO
                    AND SC.CDLINPCLIE = COL.CDLINPCLIE
                    AND SI.CDSISTEMA = SC.CDSISTEMA
                    AND PR.CDPROCOMERCI = SI.CDPROCOMERCI
                GROUP BY COL.NRSEQCONTRATO,
                         COL.NMLINPCLIE,
                         COL.NRPRODUTO_ID) LIC ON (LIC.NRCONT = TBL.NRSEQCONTRATO
                                                   AND IDARVOREPAI IS NULL
                                                   AND LIC.NRPRODUTO_ID = REPLACE(TBL.IDELEMENTO, 'P_', ''))))
 ORDER BY IDARVORE DESC";
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    // Já atualizado
    public function getItensValorAgrupado($params)
    {
        $sql = "SELECT IDARVORE,
        IDARVOREPAI,
        :NRAGRUPAMENTO AS NRAGRUPAMENTO,
        :DTFINCOMPET AS DTFINCOMPET,
        :DTINICOMPET AS DTINICOMPET,
        NRSEQCONTRATO,
        NRCONTRATOFCT,
        NRFATURACONT,
        NRITFATURACONT,
        VRSEMDESCONTO,
        VRVENCIMENTO,
        VRPERCDESCITEM,
        VRDESCITEM,
        NMITEMCONTRATO,
        IDFORMAFATURA,
        IDALTUSUARIO,
        DSJUSTIFICATIVA,
        VARIABLE_MEASURE,
        IDELEMENTO,
        CDSERVORCA,
        ISSERV,
        NVL2(IDARVOREPAI, NULL, VRNEGCONTR) AS VRNEGCONTR,
        QTMEDIDACONTR AS QTMINIMA,
        QTMEDIDAMEDICAO AS QTCONSIDERADA
 FROM
     (SELECT IDARVORE,
             IDARVOREPAI,
             NRSEQCONTRATO,
             NRCONTRATOFCT,
             NRFATURACONT,
             NRITFATURACONT,
             ROUND(VRSEMDESCONTO, 2) AS VRSEMDESCONTO,
             ROUND(VRVENCIMENTO, 2) AS VRVENCIMENTO,
             ROUND(VRPERCDESCITEM, 2) AS VRPERCDESCITEM,
             ROUND(VRDESCITEM, 2) AS VRDESCITEM,
             NMITEMCONTRATO,
             IDFORMAFATURA,
             IDALTUSUARIO,
             DSJUSTIFICATIVA,
             VARIABLE_MEASURE,
             IDELEMENTO,
             CDSERVORCA,
             ISSERV,
             VRNEGCONTR,
             QTMEDIDACONTR,
             QTMEDIDAMEDICAO
      FROM
          (SELECT IDARVORE,
                  IDARVOREPAI,
                  NRSEQCONTRATO,
                  NRCONTRATOFCT,
                  IDSITUACAO,
                  NRFATURACONT,
                  NRITFATURACONT,
                  VRUNITARIO,
                  DECODE(IDARVOREPAI, NULL, (SELECT SUM(VRITEMCONT) 
                            FROM FCT_MEDVARMEDICAOFATURA
                            WHERE 'M'||NRMEDICAOFATURA = :NRFATURACONT), DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR)) AS VRSEMDESCONTO,
                  CASE
                      WHEN IDARVOREPAI IS NULL THEN VRITEMCONT
                      ELSE VRITEMCONTCOMDESC_MEDVAR
                  END AS VRVENCIMENTO,
                  DECODE(IDARVOREPAI, NULL, DECODE(VRTOTITEMCONT, 0, 0, (VRDESCITEM * 100) / VRTOTITEMCONT), DECODE(VRITEMCONT_MEDVAR, 0, 0, (VRDESCITEM * 100) / VRITEMCONT_MEDVAR)) AS VRPERCDESCITEM,
                  VRDESCITEM,
                  NMITEMCONTRATO,
                  IDFORMAFATURA,
                  IDALTUSUARIO,
                  DSJUSTIFICATIVA,
                  VRTOTITEMCONT,
                  QTMEDIDACONTR,
                  QTMEDIDAMEDICAO,
                  VARIABLE_MEASURE,
                  IDELEMENTO,
                  CDSERVORCA,
                  
                  VRITEMCONT_MEDVAR,
                   VRITEMCONTCOMDESC_MEDVAR,
    
                   VRPERCDESCITEM_ITNEG, 
                   VRDESCITEM_ITNEG,
                   VRTOTITEM_ITNEG,
 
               (SELECT COUNT(*)
                FROM FCT_RELACMEDIDACONTRATO
                WHERE NRSEQCONTRATO = TBL.NRSEQCONTRATO
                    AND CDSERVORCA = TBL.CDSERVORCA) AS ISSERV,
                  NVL2(IDARVOREPAI, NULL, NVL2(NRPARCELASNEGCONTR, VRNEGCONTR, :VRNEGCONTR / :VRORIGINAL * VRITEMCONT)) AS VRNEGCONTR
           FROM
               (SELECT TO_CHAR(ITCONT.NRITEMOCONTRATO) AS IDARVORE,
                       TO_CHAR(ITCONT.NRITEMCONTRATOPAI) AS IDARVOREPAI,
                       CONT.NRSEQCONTRATO,
                       CONT.NRCONTRATOFCT,
                       MED.IDSITUACAO,
                       ITMED.NRMEDICAOFATURA AS NRFATURACONT,
                       ITMED.NRITMEDICAOFATURA AS NRITFATURACONT,
                       ITMED.VRITEMCONT,
                       DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, NULL, DECODE(MEDVAR.QTMEDIDAMEDICAO, 0, 0, DECODE(NVL(VAR.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, ITCONT.VRUNITITEMCONT / VARVEND.VRPRECOVARIACAO * VAR.VRPRECOVARIACAO)))) AS VRUNITARIO,
                       DECODE(REL.IDPARCAGRUP, 'S', DECODE(ITCONT.NRITEMCONTRATOPAI, NULL, ITCONT.NMITEMCONTRATO || ' (' || ORC.NRORCAMENTO || DECODE(LIC.NMLINPCLIE, NULL, '', ' - ' || LIC.NMLINPCLIE) || ')', ITCONT.NMITEMCONTRATO), ITCONT.NMITEMCONTRATO) AS NMITEMCONTRATO,
                       NULL AS IDFORMAFATURA,
                       NULL AS IDALTUSUARIO,
                       NULL AS DSJUSTIFICATIVA,
                       ITCONT.QTMEDIDACONTR,
                       ITMED.VRTOTITEMCONT,
                       DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, (NVL(ITMED.VRTOTITEMCONT, 0) - NVL(ITMED.VRITEMCONT, 0)), (NVL(MEDVAR.VRITEMCONT, 0) - NVL(MEDVAR.VRITEMCONTCOMDESC, 0))) AS VRDESCITEM,
                       MEDVAR.IDMULTIPVARIACAO,
                       MEDVAR.QTMEDIDAMEDICAO,
                       DECODE(REL.NRMEDICAOFATURA, NULL, 'N', 'Y') AS VARIABLE_MEASURE,
                       ITCONT.IDELEMENTO,
                       ITCONT.CDSERVORCA,
                       NVL2(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.VRNEGCONTR) AS VRNEGCONTR,
                       NVL2(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.NRPARCELASNEGCONTR) AS NRPARCELASNEGCONTR,
                       
                       MEDVAR.VRITEMCONT AS VRITEMCONT_MEDVAR,
                       MEDVAR.VRITEMCONTCOMDESC AS VRITEMCONTCOMDESC_MEDVAR,
                    
                       ITNEG.VRPERCDESCITEM as VRPERCDESCITEM_ITNEG, 
                       ITNEG.VRDESCITEM as  VRDESCITEM_ITNEG,
                       ITNEG.VRTOTITEM AS VRTOTITEM_ITNEG
                FROM FCT_ITMEDICAOFATURA ITMED
                INNER JOIN FCT_MEDICAOFATURA MED ON ITMED.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                INNER JOIN FCT_RELACAGRUPCONTFAT REL ON MED.NRMEDICAOFATURA = REL.NRMEDICAOFATURA
                AND MED.NRSEQCONTRATO = REL.NRSEQCONTRATO
                INNER JOIN FCT_CONTRATO CONT ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                LEFT JOIN FCT_REFEORCACONT REF ON CONT.NRSEQCONTRATO = REF.NRSEQCONTRATO
                LEFT JOIN FCT_ORCAMENTO ORC ON REF.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                INNER JOIN FCT_ITEMCONTRATO ITCONT ON MED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                AND ITMED.CDSERVORCA = ITCONT.CDSERVORCA
                INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                INNER JOIN FCT_NEGOCIACAOCONTRATO NEG ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                LEFT JOIN FCT_MEDVARMEDICAOFATURA MEDVAR ON MED.NRMEDICAOFATURA = MEDVAR.NRMEDICAOFATURA
                AND ITCONT.CDSERVORCA = MEDVAR.CDSERVORCA
                AND ITCONT.IDELEMENTO = MEDVAR.IDELEMENTORAIZ
                AND ITCONT.CDTPMEDIDAVARIAVEL = MEDVAR.CDTPMEDIDAVARIAVEL
                LEFT JOIN FCT_VARPRECBASESERVCONT VAR ON MED.NRSEQCONTRATO = VAR.NRSEQCONTRATO
                AND ITCONT.CDTPMEDIDASERV = VAR.CDTPMEDIDASERV
                AND ITCONT.CDTPMEDIDAVARIAVEL = VAR.CDTPMEDIDAVARIAVEL
                AND MED.NRORG = VAR.NRORG
                AND MEDVAR.CDSERVORCA = VAR.CDSERVORCA
                AND (MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA) BETWEEN VAR.QTMEDIDAINIVARIACAO AND VAR.QTMEDIDAFIMVARIACAO
                LEFT JOIN FCT_VARPRECBASESERVCONT VARVEND ON MED.NRSEQCONTRATO = VARVEND.NRSEQCONTRATO
                AND ITCONT.CDTPMEDIDASERV = VARVEND.CDTPMEDIDASERV
                AND ITCONT.CDTPMEDIDAVARIAVEL = VARVEND.CDTPMEDIDAVARIAVEL
                AND MED.NRORG = VARVEND.NRORG
                AND MEDVAR.CDSERVORCA = VARVEND.CDSERVORCA
                AND DECODE(NVL(MEDVAR.QTMEDIDAVENDIDA, 0), 0, 1, MEDVAR.QTMEDIDAVENDIDA) BETWEEN VARVEND.QTMEDIDAINIVARIACAO AND VARVEND.QTMEDIDAFIMVARIACAO
                LEFT JOIN
                    (SELECT COL.NMLINPCLIE || ' - ' || '(' || TO_CHAR(RTRIM(XMLAGG(XMLELEMENT(e, SI.SGSISTEMA, ', ').EXTRACT('//text()')).GetClobVal(), ', ')|| ')') AS NMLINPCLIE,
                            COL.NRSEQCONTRATO AS NRCONT,
                            COL.NRPRODUTO_ID
                     FROM SISTCONTLINP SC,
                          SISTEMA SI,
                          PROCOMERCI PR,
                          CONTRATOLINP COL,
                          CLIENTE CLI
                     WHERE SC.CDCLIENTE = CLI.CDCLIENTE
                         AND CLI.NRPARCNEGOCIO = :NRPARCNEGOCIO
                         AND SC.CDLINPCLIE = COL.CDLINPCLIE
                         AND SI.CDSISTEMA = SC.CDSISTEMA
                         AND PR.CDPROCOMERCI = SI.CDPROCOMERCI
                     GROUP BY COL.NRSEQCONTRATO,
                              COL.NMLINPCLIE,
                              COL.NRPRODUTO_ID) LIC ON (LIC.NRCONT = CONT.NRSEQCONTRATO
                                                        AND ITCONT.NRITEMCONTRATOPAI IS NULL
                                                        AND LIC.NRPRODUTO_ID = REPLACE(ITCONT.IDELEMENTO, 'P_', ''))
                WHERE 'A' || REL.NRFATURACONT = :NRFATURACONT
                    AND MED.NRORG = :NRORG
                    AND (ITCONT.IDELEMENTO IS NULL
                         OR ITCONT.IDELEMENTO IN
                             (SELECT IDELEMENTORAIZ
                              FROM FCT_RELACMEDIDACONTRATO
                              WHERE NRSEQCONTRATO = CONT.NRSEQCONTRATO))) TBL
        ))
                            
 ORDER BY IDARVORE DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    // Já atualizado
    public function getItensValorAgrupadoEstimado($params)
    {
        $sql =  "SELECT IDARVORE,
        IDARVOREPAI,
        NRSEQCONTRATO,
        NRCONTRATOFCT,
        NRFATURACONT,
        NRITFATURACONT,
        VRSEMDESCONTO,
        VRVENCIMENTO,
        VRPERCDESCITEM,
        VRDESCITEM,
        NMITEMCONTRATO,
        IDFORMAFATURA,
        IDALTUSUARIO,
        DSJUSTIFICATIVA,
        VARIABLE_MEASURE,
        IDELEMENTO,
        CDSERVORCA,
        ISSERV,
        NVL2(IDARVOREPAI, NULL, VRNEGCONTR) AS VRNEGCONTR,
        QTMEDIDACONTR AS QTMINIMA,
        QTMEDIDAMEDICAO AS QTCONSIDERADA
 FROM
     (SELECT IDARVORE,
             IDARVOREPAI,
             NRSEQCONTRATO,
             NRCONTRATOFCT,
             NRFATURACONT,
             NRITFATURACONT,
             ROUND(VRSEMDESCONTO, 2) AS VRSEMDESCONTO,
             ROUND(VRVENCIMENTO, 2) AS VRVENCIMENTO,
             ROUND(VRPERCDESCITEM, 2) AS VRPERCDESCITEM,
             ROUND(VRDESCITEM, 2) AS VRDESCITEM,
             NMITEMCONTRATO,
             IDFORMAFATURA,
             IDALTUSUARIO,
             DSJUSTIFICATIVA,
             'Y' AS VARIABLE_MEASURE,
             IDELEMENTO,
             CDSERVORCA,
             ISSERV,
             VRNEGCONTR,
             QTMEDIDACONTR,
             QTMEDIDAMEDICAO
      FROM
          (SELECT IDARVORE,
                  IDARVOREPAI,
                  NRSEQCONTRATO,
                  NRCONTRATOFCT,
                  IDSITUACAO,
                  NRFATURACONT,
                  NRITFATURACONT,
                  VRUNITARIO,
                  DECODE(IDARVOREPAI, NULL, (SELECT SUM(VRITEMCONT) 
                      FROM FCT_MEDVARMEDICAOFATURA
                      WHERE 'M'||NRMEDICAOFATURA = :NRFATURACONT), DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR)) AS VRSEMDESCONTO,
                  CASE
                      WHEN IDARVOREPAI IS NULL THEN VRITEMCONT
                      ELSE VRITEMCONTCOMDESC_MEDVAR
                  END AS VRVENCIMENTO,
                  DECODE(IDARVOREPAI, NULL, DECODE(VRTOTITEMCONT, 0, 0, (VRDESCITEM * 100) / VRTOTITEMCONT), DECODE(VRITEMCONT_MEDVAR, 0, 0, (VRDESCITEM * 100) / VRITEMCONT_MEDVAR)) AS VRPERCDESCITEM,
                  VRDESCITEM,
                  DECODE(LIC.NMLINPCLIE, NULL, NMITEMCONTRATO, NMITEMCONTRATO || ' (' || LIC.NMLINPCLIE || ')') AS NMITEMCONTRATO,
                  IDFORMAFATURA,
                  IDALTUSUARIO,
                  DSJUSTIFICATIVA,
                  VRTOTITEMCONT,
                  QTMEDIDACONTR,
                  QTMEDIDAMEDICAO,
                  IDELEMENTO,
                  CDSERVORCA,
                  
                  VRITEMCONT_MEDVAR,
                  VRITEMCONTCOMDESC_MEDVAR,
  
                  VRPERCDESCITEM_ITNEG, 
                  VRDESCITEM_ITNEG,
                  VRTOTITEM_ITNEG,
 
               (SELECT COUNT(*)
                FROM FCT_RELACMEDIDACONTRATO
                WHERE NRSEQCONTRATO = TBL.NRSEQCONTRATO
                    AND CDSERVORCA = TBL.CDSERVORCA ) AS ISSERV,
                  NVL2(IDARVOREPAI, NULL, NVL2(NRPARCELASNEGCONTR, VRNEGCONTR, : VRNEGCONTR / : VRORIGINAL * VRITEMCONT)) AS VRNEGCONTR
           FROM
               (SELECT TO_CHAR(ITCONT.NRITEMOCONTRATO) AS IDARVORE,
                       TO_CHAR(ITCONT.NRITEMCONTRATOPAI) AS IDARVOREPAI,
                       CONT.NRSEQCONTRATO,
                       CONT.NRCONTRATOFCT,
                       MED.IDSITUACAO,
                       ITMED.NRMEDICAOFATURA AS NRFATURACONT,
                       ITMED.NRITMEDICAOFATURA AS NRITFATURACONT,
                       ITMED.VRITEMCONT,
                       DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, NULL, DECODE(MEDVAR.QTMEDIDAMEDICAO, 0, 0, DECODE(NVL(VAR.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, ITCONT.VRUNITITEMCONT, ITCONT.VRUNITITEMCONT / VARVEND.VRPRECOVARIACAO * VAR.VRPRECOVARIACAO)))) AS VRUNITARIO,
                       ITCONT.NMITEMCONTRATO,
                       NULL AS IDFORMAFATURA,
                       NULL AS IDALTUSUARIO,
                       NULL AS DSJUSTIFICATIVA,
                       ITCONT.QTMEDIDACONTR,
                       ITMED.VRTOTITEMCONT,
                       DECODE(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, (NVL(ITMED.VRTOTITEMCONT, 0) - NVL(ITMED.VRITEMCONT, 0)), (NVL(MEDVAR.VRITEMCONT, 0) - NVL(MEDVAR.VRITEMCONTCOMDESC, 0))) AS VRDESCITEM,
                       MEDVAR.IDMULTIPVARIACAO,
                       MEDVAR.QTMEDIDAMEDICAO,
                       ITCONT.IDELEMENTO,
                       ITCONT.CDSERVORCA,
                       NVL2(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.VRNEGCONTR) AS VRNEGCONTR,
                       NVL2(MEDVAR.NRMEDVARMEDICAOFATURA, NULL, ITMED.NRPARCELASNEGCONTR) AS NRPARCELASNEGCONTR,
                       
                       MEDVAR.VRITEMCONT AS VRITEMCONT_MEDVAR,
                       MEDVAR.VRITEMCONTCOMDESC AS VRITEMCONTCOMDESC_MEDVAR,
                      
                       ITNEG.VRPERCDESCITEM as VRPERCDESCITEM_ITNEG, 
                       ITNEG.VRDESCITEM as  VRDESCITEM_ITNEG,
                       ITNEG.VRTOTITEM AS VRTOTITEM_ITNEG
                      
                FROM FCT_ITMEDICAOFATURA ITMED
                INNER JOIN FCT_MEDICAOFATURA MED ON ITMED.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                INNER JOIN FCT_RELACAGRUPAMENTOCONT RAC ON MED.NRSEQCONTRATO = RAC.NRSEQCONTRATO
                AND MED.NRORG = RAC.NRORG
                INNER JOIN FCT_AGRUPAMENTO AGRU ON RAC.NRAGRUPAMENTO = AGRU.NRAGRUPAMENTO
                AND RAC.NRORG = AGRU.NRORG
                INNER JOIN FCT_CONTRATO CONT ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                INNER JOIN FCT_ITEMCONTRATO ITCONT ON MED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                AND ITMED.CDSERVORCA = ITCONT.CDSERVORCA
                INNER JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                INNER JOIN FCT_NEGOCIACAOCONTRATO NEG ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                LEFT JOIN FCT_MEDVARMEDICAOFATURA MEDVAR ON MED.NRMEDICAOFATURA = MEDVAR.NRMEDICAOFATURA
                AND ITCONT.CDSERVORCA = MEDVAR.CDSERVORCA
                AND ITCONT.IDELEMENTO = MEDVAR.IDELEMENTORAIZ
                AND ITCONT.CDTPMEDIDAVARIAVEL = MEDVAR.CDTPMEDIDAVARIAVEL
                LEFT JOIN FCT_VARPRECBASESERVCONT VAR ON MED.NRSEQCONTRATO = VAR.NRSEQCONTRATO
                AND ITCONT.CDTPMEDIDASERV = VAR.CDTPMEDIDASERV
                AND ITCONT.CDTPMEDIDAVARIAVEL = VAR.CDTPMEDIDAVARIAVEL
                AND MED.NRORG = VAR.NRORG
                AND MEDVAR.CDSERVORCA = VAR.CDSERVORCA
                AND (MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA) BETWEEN VAR.QTMEDIDAINIVARIACAO AND VAR.QTMEDIDAFIMVARIACAO
                LEFT JOIN FCT_VARPRECBASESERVCONT VARVEND ON MED.NRSEQCONTRATO = VARVEND.NRSEQCONTRATO
                AND ITCONT.CDTPMEDIDASERV = VARVEND.CDTPMEDIDASERV
                AND ITCONT.CDTPMEDIDAVARIAVEL = VARVEND.CDTPMEDIDAVARIAVEL
                AND MED.NRORG = VARVEND.NRORG
                AND MEDVAR.CDSERVORCA = VARVEND.CDSERVORCA
                AND DECODE(NVL(MEDVAR.QTMEDIDAVENDIDA, 0), 0, 1, MEDVAR.QTMEDIDAVENDIDA) BETWEEN VARVEND.QTMEDIDAINIVARIACAO AND VARVEND.QTMEDIDAFIMVARIACAO
                WHERE MED.NRPARCFATURA = : NRPARCNEGOCIO
                    AND :NRFATURACONT IS NOT NULL
                    AND MED.NRORG = : NRORG
                    AND RAC.NRAGRUPAMENTO = : NRAGRUPAMENTO
                    AND MED.IDSITUACAO = '3'
                    AND TRUNC(MED.DTINICOMPET) = : DTINICOMPET
                    AND TRUNC(MED.DTFINCOMPET) = : DTFINCOMPET
                    AND (ITCONT.IDELEMENTO IS NULL
                         OR ITCONT.IDELEMENTO IN
                             (SELECT IDELEMENTORAIZ
                              FROM FCT_RELACMEDIDACONTRATO
                              WHERE NRSEQCONTRATO = CONT.NRSEQCONTRATO )) ) TBL
           LEFT JOIN
               (SELECT COL.NMLINPCLIE || ' - ' || '(' || TO_CHAR(RTRIM(XMLAGG(XMLELEMENT(e, SI.SGSISTEMA, ', ').EXTRACT('//text()')).GetClobVal(), ', ') || ')') AS NMLINPCLIE,
                       COL.NRSEQCONTRATO AS NRCONT,
                       COL.NRPRODUTO_ID
                FROM SISTCONTLINP SC,
                     SISTEMA SI,
                     PROCOMERCI PR,
                     CONTRATOLINP COL,
                     CLIENTE CLI
                WHERE SC.CDCLIENTE = CLI.CDCLIENTE
                    AND CLI.NRPARCNEGOCIO = : NRPARCNEGOCIO
                    AND SC.CDLINPCLIE = COL.CDLINPCLIE
                    AND SI.CDSISTEMA = SC.CDSISTEMA
                    AND PR.CDPROCOMERCI = SI.CDPROCOMERCI
                GROUP BY COL.NRSEQCONTRATO,
                         COL.NMLINPCLIE,
                         COL.NRPRODUTO_ID) LIC ON (LIC.NRCONT = TBL.NRSEQCONTRATO
                                                   AND IDARVOREPAI IS NULL
                                                   AND LIC.NRPRODUTO_ID = REPLACE(TBL.IDELEMENTO, 'P_', ''))))
 ORDER BY IDARVORE DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function findBilletIssuedFct($params)
    {
        $sql =   " SELECT CDFILIAL, NRLANBOLREC, CDREDUCONT, CDBANCO
                FROM (SELECT C.CDFILIAL,BO.NRLANBOLREC,BO.CDREDUCONT, CC.CDBANCO
                        FROM CONTARECEBER C
                        JOIN NOTAFISCAL N ON (N.NRLANCTONF = C.NRLANCTONF AND N.CDFILIAL = C.CDFILIAL AND N.NRORG = C.NRORG )
                        JOIN CLIENTE CLI ON (N.CDCLIENTE = CLI.CDCLIENTE AND N.NRORG = CLI.NRORG)
                        JOIN BOLETRECEBER BO ON (BO.NRLANBOLREC = C.NRLANBOLREC AND BO.CDFILIAL = C.CDFILIAL)
                        JOIN FCT_APURACAO APU ON APU.NRLANCTONF = N.NRLANCTONF AND APU.CDFILIAL = N.CDFILIAL
                        JOIN CONTCORR CC ON BO.CDREDUCONT = CC.CDREDUCONT
                   WHERE APU.NRLANCTONF = :NRLANCTONF)
      
                   GROUP BY CDFILIAL, NRLANBOLREC, CDREDUCONT,CDBANCO";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function getNrparcnegocio($param)
    {
        $sql = "SELECT NRPARCNEGOCIO
                FROM CLIENTE
                WHERE CDCLIENTE = '$param' ";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }
}
